local ScriptLoaded = false

if not PlayerAnimInfo
	rawset(_G, "PlayerAnimInfo", {})
end

PlayerAnimInfo["nilly"] = {
		["runFrames"] = {3, 7},
		["dashFrames"] = {0, 2},
		["walkFrames"] = {3, 7},
		["waitFrames"] = {0},
		["milnekickFrames"] = {0, 4},
		["run"] = true,
		["dash"] = true,
		["walk"] = true,
		["idle"] = true,
		["wait"] = false,
		["milnekick"] = true,
		["superRun"] = false,
		["superDash"] = false,
		["superWalk"] = true,
		["superIdle"] = true,
		["superWait"] = false
}

local SKIN = "nilly"

local WaterFactor = function(mo, val, dir)
 if mo and mo.valid
  local water = 0
  local water2
  
  if dir == nil or dir == 0 //vertical factor
   water = ((mo.eflags&MFE_UNDERWATER) or P_IsObjectInGoop(mo) or mo.player and (mo.player.powers[pw_spacetime])) and 2 or 1
   water2 = ((mo.eflags&MFE_UNDERWATER) or P_IsObjectInGoop(mo) or mo.player and (mo.player.powers[pw_spacetime])) and 3 or 1
  elseif dir == 1 //horizontal factor
   water = 1
   water2 = ((mo.eflags&MFE_UNDERWATER) or P_IsObjectInGoop(mo) or mo.player and (mo.player.powers[pw_spacetime])) and 2 or 1
  end
  
  local rval = (water*val)/water2
  return rval
 else
  return
 end
end

//homing attack function reused from flame's sonic lost world homing attack

//source = player
rawset(_G, "L_NillyHomingAttack", function(source, enemy)
	local zdist, dist
	local ns = 0
	
	if not enemy or not enemy.valid then return false end
	
	if (enemy.health <= 0)
	//or (enemy.flags & MF_NOCLIPTHING)
	or (enemy.flags2 & MF2_FRET) then
		return false
	end
	
	-- Set Angle
	--source.angle = R_PointToAngle2(source.x, source.y, enemy.x, enemy.y)
	-- Set Slope
	zdist = (P_MobjFlip(source) == -1) and ((enemy.z + enemy.height) - (source.z + source.height)) or (enemy.z - source.z)
	dist = FixedHypot(FixedHypot(enemy.x - source.x, enemy.y - source.y), zdist)
	dist = max($, 1)
	
	if (source.type == MT_PLAYER) -- Specific dummy check
		ns = FixedMul(30*FRACUNIT, source.scale)
	else -- Everything else
		if (source.threshold == 32000) then
			ns = FixedMul(source.info.speed/2, source.scale)
		else
			ns = FixedMul(source.info.speed, source.scale)
		end
	end
	
	source.momx = FixedMul(FixedDiv(enemy.x - source.x, dist), ns)
	source.momy = FixedMul(FixedDiv(enemy.y - source.y, dist), ns)
	source.momz = FixedMul(FixedDiv(zdist, dist), ns)
	return true
end)

//gonna make 3 states; windup, arm launch, and bringing the arms back, and then grabbing as a secondary Boolean.
//jump when winding up to kangaroo kick(?), grabbing floors allow for crouching if by the contact point, moving allows for a spindash effect
//make sure that grabbing walls allow for climbing, crouch + jump begins a fake spindash that breaks said walls, and hanging from ceilings is possible.
//make a separate object for the hands too, so it can break and attack separately from the player.

freeslot("MT_NILARMS", "S_NILLY_SKYCLING", "S_NILLY_ARMUSE_LAUNCH", "S_NILLY_ARMUSE", "S_NILLY_ARMUSE_WALK", "S_NILLY_ARMUSE_RETURN", "S_NILLY_ARMUSE_FINISH", "S_NILLY_CROUCH")
freeslot("S_NILARMS1", "S_NILARMS2", "S_NILARMS_ATTACK1", "S_NILARMS_ATTACK2", "S_NILARMS_RETURN1", "S_NILARMS_RETURN2", "MT_NILARMS_TRAIL")
freeslot("SPR_NWT0", "SPR_NWT1", "SPR_NWT2")

mobjinfo[MT_NILARMS] = {
        doomednum = -1,
        spawnstate = S_NILARMS_ATTACK1,
        spawnhealth = 1,
        seestate = S_NILARMS_ATTACK1,
        seesound = sfx_none,
        reactiontime = 0,
        attacksound = sfx_zoom,
        painstate = S_NILARMS1,
        painchance = MT_THOK,
        painsound = sfx_None,
        meleestate = S_NILARMS_ATTACK1,
        missilestate = S_NILARMS_RETURN1,
        deathstate = S_NILARMS2,
        xdeathstate = S_NULL,
        deathsound = sfx_s3k4a,
        speed = 60*FRACUNIT,
        radius = 12*FRACUNIT,
        height = 30*FRACUNIT,
        dispoffset = 0,
        mass = DMG_SPIKE,
        activesound = sfx_s3k7e,
        flags = MF_MISSILE|MF_NOGRAVITY,
}

mobjinfo[MT_NILARMS_TRAIL] = {
        doomednum = -1,
        spawnstate = S_THOK,
        spawnhealth = 1,
        seestate = S_THOK,
        seesound = sfx_none,
        reactiontime = 0,
        attacksound = sfx_none,
        painstate = S_NULL,
        painsound = sfx_None,
        meleestate = S_NULL,
        missilestate = S_NULL,
        deathstate = S_NULL,
        xdeathstate = S_NULL,
        deathsound = sfx_none,
        speed = 20*FRACUNIT,
        radius = 25*FRACUNIT,
        height = 20*FRACUNIT,
        dispoffset = 0,
        mass = DMG_SPIKE,
        activesound = sfx_none,
        flags = MF_NOGRAVITY|MF_MISSILE|MF_NOCLIPHEIGHT,
}

states[S_NILARMS1] = {
		sprite = SPR_NWT0,
		frame = A,
		var1 = 0,
		var2 = 0,
		tics = -1,
		nextstate = S_NILARMS1
}

states[S_NILARMS2] = {
		sprite = SPR_NWT1,
		frame = A,
		var1 = 0,
		var2 = 0,
		tics = -1,
		nextstate = S_NILARMS2
}

states[S_NILARMS_ATTACK1] = {
		sprite = SPR_NWT1,
		frame = A,
		var1 = 0,
		var2 = 0,
		tics = 33,
		nextstate = S_NILARMS_RETURN1
}

states[S_NILARMS_RETURN1] = {
		sprite = SPR_NWT2,
		frame = A,
		var1 = 0,
		var2 = 0,
		tics = -1,
		nextstate = S_NILARMS_RETURN1
}

states[S_NILARMS_RETURN2] = {
		sprite = SPR_NWT2,
		frame = A,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_NILARMS_RETURN1
}

states[S_NILLY_ARMUSE_LAUNCH] = {
		sprite = SPR_PLAY,
		frame = SPR2_FIRE,
		var1 = 0,
		var2 = 0,
		tics = -1,
		nextstate = S_NILLY_ARMUSE_LAUNCH
}

states[S_NILLY_ARMUSE] = {
		sprite = SPR_PLAY,
		frame = SPR2_BNCE,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_NILLY_ARMUSE,
}

states[S_NILLY_SKYCLING] = {
		sprite = SPR_PLAY,
		frame = SPR2_RIDE,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_NILLY_SKYCLING,
}

states[S_NILLY_ARMUSE_WALK] = {
		sprite = SPR_PLAY,
		frame = SPR2_FRUN,
		var1 = 0,
		var2 = 0,
		tics = 4,
		nextstate = S_NILLY_ARMUSE_WALK
}

states[S_NILLY_ARMUSE_FINISH] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|SPR2_TIRE,
		var1 = S_PLAY_SKID,
		var2 = 0,
		tics = 2,
		nextstate = S_NILLY_ARMUSE_FINISH,
}

states[S_NILLY_CROUCH] = {
		sprite = SPR_PLAY,
		frame = SPR2_LAND,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_NILLY_CROUCH
}

states[S_NILLY_ARMUSE_RETURN] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2SUPER|SPR2_FIRE,
		var1 = 0,
		var2 = 0,
		tics = -1,
		nextstate = S_NILLY_ARMUSE_RETURN,
}


addHook("ThinkFrame", function()
	if not(ScriptLoaded)
		and CBW_Battle
		then
		ScriptLoaded = true
		local B = CBW_Battle
		
		local WaterTailFunction = function(mo,doaction)
			local player = mo.player
			
			if player.norundist == nil
				player.norundist = 0
			end

			if player.nillyarms == nil
			player.nillyarms = {}
			else
			local narms = player.nillyarms
		   
			if (player.playerstate ~= PST_LIVE) or not(B.CanDoAction(player) and player.actionstate ~= 1)
				player.actionstate = 0
				narms.launchtime = 0
				return
			end
			
			player.actiontext = "Aqua-Tail Punch"
			player.actionrings = 10
			player.action2text = "Overhead Cancel"
			player.action2rings = 5
			
			player.action2text = nil
			if player.actionstate != 0 or player.nillyarms.launchstate ~= 0 then player.canguard = false end

			
			if player.nillyarms ~= nil and player.actionstate == 0 and doaction == 1 and not player.nillyarms.reset
			and player.mo.state ~= S_NILLY_ARMUSE_FINISH and not (player.powers[pw_carry])
			and player.charability2 == CA2_MELEE and not (player.pflags&PF_SPINNING)
				player.actionstate = 5
				player.nillyarms.launchstate = 5
				player.nillyarms.launchtime = TICRATE * 5/10 //max delay
				player.mo.momx = $ * 7/8
				player.mo.momy = $ * 7/8
				player.mo.momz = $/2
				player.nillyarms.angle = player.mo.angle
				player.drawangle = player.mo.angle
				player.mo.angle = player.mo.angle
				
				if not P_IsObjectOnGround(player.mo)
				P_SetObjectMomZ(player.mo, 9/2*FRACUNIT, true)
				end
				
				S_StartSound(player.mo, sfx_spndsh)
				player.mo.state = S_NILLY_ARMUSE
				player.pflags = $|PF_THOKKED
			  
				B.ApplyCooldown(player, TICRATE*2)
			
				B.PayRings(player)
		   
				//print("charge")
				return //true
			end
			
		   
			narms.reset = (player.mo.state == S_PLAY_PAIN or player.playerstate ~= PST_LIVE or player.powers[pw_carry] or player.powers[pw_justsprung]) and true or false

			if narms.launchtime ~= nil
				narms.launchtime = $ > 0 and $ - 1 or 0
			else
				narms.launchtime = 0
			end

			/*if player.mo.state ~= S_PLAY_MELEE and player.mo.state ~= S_PLAY_MELEE_FINISH and player.charability2 == CA2_MELEE
				player.charability2 = CA2_SPINDASH
			end*/
		   
			if narms.launchstate == nil
				narms.launchstate = 0
			else
				
				if (player.actionstate == 1 or narms.launchstate == 1)
				 if not (player.cmd.buttons&BT_ATTACK)
				  player.actionstate = 0
				  narms.launchstate = 0
				  player.mo.state = S_NILLY_ARMUSE_FINISH
				  S_StartSound(player.mo, sfx_s3k4a)
				  if not P_IsObjectOnGround(player.mo)
					P_SetObjectMomZ(player.mo, WaterFactor(player.mo, FRACUNIT*7), true)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_JUMPED & ~PF_THOKKED
				  end
				  //print("release")
				 end
				if player.mo.state == S_PLAY_SPINDASH
				 player.actionspd = 30*FRACUNIT
				 /*if narms.arms and narms.arms.valid
				  P_HomingAttack(player.mo, narms.arms)
				 end*/
				else
					 if narms.arms and narms.arms.valid
						if player.norundist < R_PointToDist2(player.mo.x, player.mo.y, narms.arms.x, narms.arms.y)
							P_Thrust(player.mo, R_PointToAngle2(player.mo.x, player.mo.y, narms.arms.x, narms.arms.y), 5*FRACUNIT)
							player.actionstate = narms.launchstate
						end
						if player.norundist*2/3 < narms.arms.z - player.mo.z //300*FRACUNIT
							player.actionstate = narms.launchstate
							P_SetObjectMomZ(player.mo, min(20*FRACUNIT, player.mo.momz*P_MobjFlip(player.mo) + WaterFactor(player.mo, 3*FRACUNIT*P_MobjFlip(player.mo))), false)
							player.mo.state = S_PLAY_ROLL
							player.pflags = $|PF_JUMPED
							P_Thrust(player.mo, R_PointToAngle2(player.mo.x, player.mo.y, narms.arms.x, narms.arms.y), 2*FRACUNIT)
						end
						if  -player.norundist*2/3 > narms.arms.z - player.mo.z //300*FRACUNIT
							P_SetObjectMomZ(player.mo, max(-20*FRACUNIT, player.mo.momz*P_MobjFlip(player.mo) + WaterFactor(player.mo, -3*FRACUNIT*P_MobjFlip(player.mo))), false)
							player.mo.state = S_PLAY_ROLL
							player.pflags = $|PF_JUMPED
							player.actionstate = narms.launchstate
							P_Thrust(player.mo, R_PointToAngle2(player.mo.x, player.mo.y, narms.arms.x, narms.arms.y), 1*FRACUNIT)
						end
					end
				end
				if P_IsObjectOnGround(player.mo) or (player.mo.eflags&MFE_JUSTHITFLOOR)
				 player.pflags = $ & ~PF_SPINNING
				 if (player.cmd.forwardmove == 0 and player.cmd.sidemove == 0)
				   player.mo.state = S_NILLY_CROUCH
				   player.panim = PA_IDLE
				 else
				   player.mo.state = S_NILLY_ARMUSE_WALK
				   player.panim = PA_WALK
				  end
				 end
				elseif (player.actionstate == 2 or narms.launchstate == 2)
					if narms.launchtime == 0
						player.actionstate = 3
						narms.launchstate = 3
						narms.launchtime = TICRATE * 2
						player.mo.state = S_NILLY_ARMUSE_RETURN
						//player.mo.frame = 0
						S_StartSound(player.mo, sfx_spin)
						//print("return")
					elseif narms.reset
						player.actionstate = 0
						S_StartSound(player.mo, sfx_s3k4a)
						  //print("reset")
					elseif narms.launchtime
						player.mo.state = S_NILLY_ARMUSE_LAUNCH
						player.mo.frame = 0
						player.drawangle = narms.angle
						player.mo.momx = $ - $/18
						player.mo.momy = $ - $/18
					end
				elseif (player.actionstate == 3 or narms.launchstate == 3)
					if narms.launchtime == 0 or narms.reset	 
					 if (narms.arms and narms.arms.valid)
					  narms.arms.target = nil
					  player.mo.target = nil
					  P_RemoveMobj(narms.arms)
					  narms.arms = nil
					 end
					 
					 player.actionstate = 0
					 narms.launchstate = 0
					 player.mo.state = S_NILLY_ARMUSE_FINISH
					 S_StartSound(player.mo, sfx_s3k4a)
					 //print("finish")
					elseif player.mo.state == S_NILLY_ARMUSE_RETURN
					 player.pflags = $|PF_STASIS
					 //player.mo.frame = 0
					 narms.launchtime = $ > 0 and $ - 1 or 0
					else
					 player.mo.state = S_NILLY_ARMUSE_RETURN
					 //player.mo.frame = 0 & ~FF_FRAMEMASK
					end
				elseif (player.actionstate == 4 or narms.launchstate == 4)
				 if player.mo.state == S_NILLY_SKYCLING
					player.mo.momx = 0
					player.mo.momy = 0
					player.mo.momz = 0
					player.pflags = $|PF_STASIS
					if not (player.cmd.buttons&BT_ATTACK)
						player.mo.state = S_PLAY_FALL
						player.actionstate = 0
						narms.launchstate = 0
						P_SetObjectMomZ(player.mo, -FRACUNIT*3, false)
						P_SpawnThokMobj(player)
						S_StartSound(player.mo, sfx_jump)
						player.pflags = $|PF_JUMPED & ~(PF_STASIS|PF_THOKKED|PF_STARTJUMP|PF_SPINNING)
						
						//S_StartSound(player.mo, sfx_s3k4a)
					end
				elseif player.mo.state == S_PLAY_CLING
					player.pflags = $|PF_STASIS
					player.mo.momx = 0
					player.mo.momy = 0
					player.mo.momz = 0
					if not (player.cmd.buttons&BT_ATTACK)
						P_Thrust(player.mo, player.drawangle, -FRACUNIT*4)
						player.mo.state = S_PLAY_JUMP
						player.actionstate = 0
						narms.launchstate = 0
						P_SetObjectMomZ(player.mo, FRACUNIT*9, false)
						//P_SpawnThokMobj(player)
						S_StartSound(player.mo, sfx_jump)
						player.pflags = $|PF_JUMPED & ~(PF_STASIS|PF_THOKKED|PF_STARTJUMP|PF_SPINNING)
						
						//S_StartSound(player.mo, sfx_s3k4a)
					end
					
					/*if (player.cmd.buttons&BT_JUMP)
						player.actionstate = 0
						player.pflags = $|PF_SPINNING|PF_STARTDASH|PF_JUMPSTASIS & ~PF_STASIS
						player.mo.state = S_PLAY_SPINDASH
						S_StartSound(player.mo, sfx_spndsh)
					end*/
				elseif player.mo.state == S_NILLY_ARMUSE or player.mo.state == S_NILLY_CROUCH
					player.pflags = $|PF_STASIS
					if not (player.cmd.buttons&BT_ATTACK)
						player.actionstate = 0
						narms.launchstate = 0
						player.mo.state = S_NILLY_ARMUSE_FINISH
					end
     
					/*if (player.cmd.buttons&BT_JUMP)
						player.actionstate = 0
						player.mo.momx = 0
						player.mo.momy = 0
						player.pflags = $|PF_SPINNING|PF_STARTDASH|PF_JUMPSTASIS & ~PF_STASIS
						player.mo.state = S_PLAY_SPINDASH
						S_StartSound(player.mo, sfx_spndsh)
					end*/
				else
					player.actionstate = 0
					narms.launchstate = 0
				end
				elseif (player.actionstate == 5 or narms.launchstate == 5)
					player.drawangle = narms.angle
					if player.mo.state ~= S_NILLY_ARMUSE
						player.mo.state = S_NILLY_ARMUSE
					end
					
					if not P_IsObjectOnGround(player.mo)
						P_SetObjectMomZ(player.mo, -P_GetMobjGravity(player.mo) * 2/4, true)
					end
					
					if (player.cmd.buttons&BT_JUMP) and not (player.pflags&PF_JUMPDOWN)
						player.actionstate = 0
						narms.launchstate = 0
						player.nillyarms.launchtime = 0
					elseif narms.launchtime <= 0 or not (player.cmd.buttons&BT_ATTACK) // Launch
						player.mo.state = S_NILLY_ARMUSE_LAUNCH
						player.actionstate = 2
						narms.launchstate = 2
						player.nillyarms.launchtime = TICRATE * 5/5
						player.nillyarms.angle = player.mo.angle
						player.drawangle = player.mo.angle
						player.mo.angle = player.mo.angle
						S_StartSound(player.mo, sfx_zoom)
						player.mo.momx = $ * 2/3
						player.mo.momy = $ * 2/3
						player.mo.momz = $/2
						
						B.ApplyCooldown(player, TICRATE*4/5)


						//spawning the arms
						local DIST = 60
						local realaim = (player.pflags&PF_FLIPCAM) and player.aiming or player.aiming
						local destx = FixedMul(player.mo.scale, DIST*cos(player.mo.angle))
						local desty = FixedMul(player.mo.scale, DIST*sin(player.mo.angle))
						local destz = FixedMul(player.mo.scale, DIST*sin(realaim))
						
						local arms = P_SpawnPointMissile(player.mo, player.mo.x + FixedMul(destx, cos(realaim)), player.mo.y + FixedMul(desty, cos(realaim)), player.mo.z + destz, MT_NILARMS, player.mo.x + FixedMul(3*FRACUNIT, cos(player.drawangle)), player.mo.y + FixedMul(3*FRACUNIT, sin(player.drawangle)), max(player.mo.z, player.mo.floorz) + FRACUNIT*2)
						
						if arms and arms.valid
							arms.target = player.mo
							player.nillyarms.arms = arms
							arms.color = SKINCOLOR_BLUE
							arms.scale = FixedMul(FRACUNIT*4/3, player.mo.scale)
							local spd = FixedHypot(arms.momx, arms.momy)
							P_InstaThrust(arms, player.drawangle, max(spd, player.speed + spd/3))
							player.norundist = FRACUNIT*300
							arms.momz = $ + 4*FRACUNIT*P_MobjFlip(player.mo)
							
							if arms.momz*P_MobjFlip(player.mo) > FRACUNIT
							arms.flags = $ & ~MF_NOGRAVITY
							elseif arms.momz*P_MobjFlip(player.mo) < -FRACUNIT
							P_SetObjectMomZ(arms, FRACUNIT*2, true)
							arms.momz = $ * 9/10
							end
							
							if arms.momz > 18*FRACUNIT or arms.momz < -18*FRACUNIT
								arms.momx = $/3
								arms.momy = $/3
								P_SetObjectMomZ(arms, min(22*FRACUNIT, max(-30*FRACUNIT, arms.momz*P_MobjFlip(arms))), false)
							end
						end
					end
				end
				end
				if (player.mo.eflags&MFE_JUSTHITFLOOR) or (player.actionstate ~= narms.launchstate) //and not P_IsObjectOnGround(player.mo)
					player.actionstate = narms.launchstate //fix it just disabling whenever
				end
			end
			player.nillyarms.launchstate = player.actionstate
		end
		
		
		local PriorityFunc = function(player)
			if player.twtime
				B.SetPriority(player,1,2,nil,2,2,"Mist Flight")
			elseif player.mo.state == S_PLAY_MELEE or player.mo.state == S_PLAY_MELEE_FINISH or (player.panim == PA_ABILITY2 and (player.pflags&PF_THOKKED))
				B.SetPriority(player,2,1,nil,3,1,"Overhead")
			elseif player.grabberpound
				B.SetPriority(player,3,2,"fang_tailbounce",3,3,"Hurricane Slam")
			elseif player.nillyarms ~= nil and (player.actionstate or player.nillyarms.arms ~= nil)
				B.SetPriority(player,2,3,nil,2,3,"Tail Launch")
			end
		end
		
		if BT_SHIELD ~= nil
		
		CBW_Battle.SkinVars[SKIN] = {
			flags = SKINVARS_GUARD,
			weight = 90,
			shields = 1,
			special = WaterTailFunction,
			guard_frame = 1,
			func_priority_ext = PriorityFunc,
			sprites = {}
		}
		else
		
		CBW_Battle.SkinVars[SKIN] = {
			flags = SKINVARS_GUARD|SKINVARS_NOSPINSHIELD,
			weight = 90,
			shields = 1,
			special = WaterTailFunction,
			guard_frame = 1,
			func_priority_ext = PriorityFunc,
			sprites = {}
		}
		end
	end
end)

addHook("PlayerThink", function(player)
 if (player.mo and player.mo.valid) and player.mo.skin == SKIN

   if player.charability ~= CA_FLY //or not (player.pflags&PF_THOKKED) and player.bot ~= 0 and player.bot ~= 2
    player.actionspd = 25*FRACUNIT
   else
    player.actionspd = skins[player.mo.skin].actionspd
   end
	
	if player.c1down ~= nil and (player.cmd.buttons&BT_ATTACK)
			player.c1down = $ + 1
		else
			player.c1down = 0
		end
  
  if player.mo.state == S_NILLY_ARMUSE_RETURN
	/*if player.mo.sprite2 ~= SPR2_FIRE
	player.mo.sprite2 = SPR2_FIRE
	end*/
	
	//player.mo.eflags = $|MFE_FORCESUPER & ~MFE_FORCENOSUPER
	//player.mo.frame = 0 //& ~FF_FRAMEMASK
	player.powers[pw_strong] = STR_ANIM|STR_GUARD
  elseif player.mo.state == S_NILLY_ARMUSE_LAUNCH
	if player.mo.sprite2 ~= SPR2_FIRE
	player.mo.sprite2 = SPR2_FIRE
	end
	//player.mo.eflags = $|MFE_FORCENOSUPER & ~MFE_FORCESUPER
	player.mo.frame = 0 //& ~FF_FRAMEMASK
	player.powers[pw_strong] = STR_ANIM|STR_PUNCH|STR_SPIKE|STR_WALL
  else
	//player.mo.eflags = $|MFE_FORCENOSUPER & ~MFE_FORCESUPER
  end
  
	if player.actionstate ~= nil 
		if (player.actionstate == 1 or player.nillyarms.launchstate == 1) and player.mo.state == S_PLAY_SPINDASH
			player.powers[pw_strong] = STR_ANIM|STR_ATTACK
		elseif (player.actionstate == 5 or player.nillyarms.launchstate == 5)
			player.powers[pw_strong] = STR_ANIM|STR_PUNCH
		end
	end
 else
  return
 end
end)

addHook("SpinSpecial", function(player)
 if (player.mo and player.mo.valid) and player.mo.skin == SKIN

  if (player.actionstate or player.nillyarms.launchstate) and player.nillyarms ~= nil
      return true
  end
 else
  return
 end
end)

addHook("JumpSpecial", function(player)
 if (player.mo and player.mo.valid) and player.mo.skin == SKIN and CBW_Battle
  if (player.pflags&PF_STARTDASH) or player.actionstate == 4 or player.nillyarms.launchstate == 4
   return true
  end

  if (player.actionstate == 5 or player.nillyarms.launchstate == 5) and not (player.pflags&PF_JUMPDOWN)
			player.actionrings = 5
			//CBW_Battle.PayRings(player)
			player.actionrings = 10
			CBW_Battle.ApplyCooldown(player, TICRATE*4/5)
			
      P_SetObjectMomZ(player.mo, player.mindash*2, false)
	  player.actionstate = 0
	  player.nillyarms.launchstate = 0
      player.nillyarms.launchtime = 0
      P_InstaThrust(player.mo, player.mo.angle, max(28*FRACUNIT, player.speed + 5*FRACUNIT))
      S_StartSound(player.mo, sfx_zoom)
      player.mo.state = S_PLAY_MELEE
      player.charability2 = CA2_MELEE
      player.powers[pw_strong] = STR_ANIM|STR_PUNCH|STR_SPIKE|STR_WALL|STR_SPRING
      player.pflags = $|PF_THOKKED|PF_JUMPED|PF_STARTJUMP
	  
      /*S_StartSound(player.mo, sfx_zoom)
      player.mo.state = S_PLAY_ROLL
      player.pflags = $|PF_THOKKED|PF_SHIELDABILITY|PF_JUMPED|PF_STARTJUMP

      if (player.powers[pw_shield] == SH_ARMAGEDDON)
      player.mo.state = S_PLAY_FALL
       P_BlackOw(player)
        player.mo.momz = 0
      end

      if (player.powers[pw_shield] == SH_WHIRLWIND or player.powers[pw_shield] == SH_THUNDERCOIN)
       //P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
       player.mo.state = S_PLAY_ROLL
       P_DoJumpShield(player)
      end

      if (player.powers[pw_shield] & SH_FORCE)
       player.mo.momx = 0
       player.mo.momy = 0
       player.mo.momz = 0
       player.mo.state = S_PLAY_FALL
      end

      if (player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_BUBBLEWRAP)
       P_SetObjectMomZ(player.mo, -20*FRACUNIT, false)
       player.mo.state = S_PLAY_ROLL
      end

      if (player.powers[pw_shield] == SH_FLAMEAURA)
       P_Thrust(player.mo, player.mo.angle, 15*FRACUNIT)
       player.mo.state = S_PLAY_ROLL
        player.mo.momz = 0
      end
      
      if (player.powers[pw_shield] == SH_ATTRACT)
       player.mo.state = S_PLAY_ROLL
       
       local enemy = P_LookForEnemies(player, true, false)
       if enemy and enemy.valid
        P_HomingAttack(player.mo, enemy)
       else
        player.mo.momz = 0
       end
      end*/
      return true
    end
 else
  return
 end
end)

addHook("MobjThinker", function(narms)
 if narms and narms.valid
  if narms.target and narms.target.valid
   local mo = narms.target
    mo.player.nillyarms.arms = narms

    local speed = FixedHypot(narms.momx, narms.momy)
   if narms.atwall == nil
    narms.atwall = 0
   end

   if narms.state == S_NILARMS_ATTACK1
    narms.momx = $ - $/35
    narms.momy = $ - $/35
     mo.target = narms
    narms.angle = mo.player.drawangle
    local ghost = P_SpawnGhostMobj(narms)
    ghost.fuse = 3
    if narms.atwall
     narms.atwall = $ - 1
    end
   end

    if (narms.momx < FRACUNIT and narms.momy < FRACUNIT and narms.momz == 0) and narms.state ~= S_NILARMS1 //and narms.state ~= S_NILARMS_RETURN1 and P_IsObjectOnGround(narms) or narms.atwall
     if (P_IsObjectOnGround(narms) or narms.z + narms.height >= narms.ceilingz)
		 narms.target.player.norundist = min(R_PointToDist2(narms.target.x, narms.target.y, narms.x, narms.y), 500*FRACUNIT)
     end
    narms.state = S_NILARMS1
    mo.player.actionstate = 1
	 mo.player.nillyarms.launchstate = 1
    end
   
   if narms.state == S_NILARMS1
    narms.momx = 0
    narms.momy = 0
    if narms.atwall
     narms.momz = 0
    end
	if mo.state == S_PLAY_SPINDASH
     mo.player.actionspd = 30*FRACUNIT
     //mo.target = narms
     //P_HomingAttack(mo, narms)
     //P_SpawnThokMobj(mo.player)
	 local ghost = P_SpawnGhostMobj(mo)
	 ghost.fuse = 3
	 
	 L_NillyHomingAttack(mo, narms)
	end
    mo.player.nillyarms.launchtime = TICRATE * 3/2
    
    local drawang = R_PointToAngle2(mo.x,mo.y, narms.x, narms.y)
    mo.player.drawangle = drawang
	narms.flags = $|MF_NOCLIPHEIGHT

    if (narms.x >= mo.x - 3*mo.radius/2 and narms.x <= mo.x + 3*mo.radius/2) and (narms.y >= mo.y - 3*mo.radius/2 and narms.y <= mo.y + 3*mo.radius/2) and (narms.z + narms.height >= mo.z and narms.z <= (mo.z + mo.height + 4*FRACUNIT))
    mo.player.actionstate = 4
	 mo.player.nillyarms.launchstate = 4
	if narms.z + narms.height >= narms.ceilingz
	 mo.state = S_NILLY_SKYCLING
	 mo.momx = 0
	 mo.momy = 0
	 P_SetOrigin(mo, narms.x, narms.y, narms.ceilingz - mo.height)
	 mo.player.pflags = $|PF_STASIS & ~(PF_THOKKED|PF_JUMPED|PF_SPINNING)
    elseif narms.atwall or (mo.player.pflags&PF_JUMPED) and not P_IsObjectOnGround(narms)
     mo.state = S_PLAY_CLING
     mo.momz = 0
    else
     mo.state = S_NILLY_CROUCH
	 mo.momx = 0
	 mo.momy = 0
	 mo.momz = 0
	 P_SetOrigin(mo, narms.x, narms.y, narms.z)
	 mo.player.pflags = $|PF_STASIS & ~(PF_THOKKED|PF_JUMPED|PF_SPINNING)
    end
     mo.target = nil
    mo.player.nillyarms.arms = nil
    mo.player.normalspeed = skins[SKIN].normalspeed
    S_StartSound(mo, sfx_s3k99)
    narms.target = nil
    P_KillMobj(narms)
    end
    if not (mo.player.cmd.buttons&BT_ATTACK)
    local ang = R_PointToAngle2(narms.x, narms.y, mo.x, mo.y)
    P_Thrust(narms, ang, FRACUNIT*2)
    narms.state = S_NILARMS_RETURN1
	
    mo.state = S_NILLY_ARMUSE_RETURN
     mo.player.actionstate = 3
	 mo.player.nillyarms.launchstate =3
    end
   end

   if narms.state == S_NILARMS_RETURN1
    local ang = R_PointToAngle2(narms.x, narms.y, mo.x, mo.y)
    local ghost = P_SpawnGhostMobj(narms)
    ghost.fuse = 3
    mo.player.norundist = FRACUNIT*300

    //P_Thrust(narms, ang, FRACUNIT*3/2)
    narms.angle = mo.player.drawangle
	narms.flags = $|MF_SLIDEME & ~MF_NOCLIPHEIGHT
    //if narms.z < mo.z
     P_HomingAttack(narms, mo)
    //end

    if (narms.x >= mo.x - 3*mo.radius/2 and narms.x <= mo.x + 3*mo.radius/2) and (narms.y >= mo.y - 3*mo.radius/2 and narms.y <= mo.y + 3*mo.radius/2) and (narms.z + narms.height >= mo.z and narms.z <= (mo.z + mo.height + 4*FRACUNIT))
    if narms.state == S_NILARMS_RETURN1
     mo.player.actionstate = 0
	 mo.player.nillyarms.launchstate = 0
     mo.state = S_NILLY_ARMUSE_FINISH
    else
     mo.player.actionstate = 1
	 mo.player.nillyarms.launchstate = 1
     mo.state = S_NILLY_CROUCH
    end
    mo.player.nillyarms.arms = nil
    mo.player.normalspeed = skins[SKIN].normalspeed
    S_StartSound(mo, sfx_s3k99)
     mo.target = nil
    narms.target = nil
    P_KillMobj(narms)
    end
   end
  else
   P_RemoveMobj(narms)
   return 
  end
 else
  return
 end
end, MT_NILARMS)

addHook("MobjMoveCollide", function(narms, enemy)
 if narms and narms.valid
   local mo = narms.target
   if (enemy and enemy.valid) and ((enemy.flags&MF_SHOOTABLE) or (enemy.type == MT_EGGSHIELD))
   and ((narms.state ~= S_NILARMS_RETURN1 or mo.state ~= S_NILLY_ARMUSE_RETURN)
   and not enemy.player and enemy.type ~= MT_PLAYER and enemy ~= mo or mo.state == S_NILLY_ARMUSE)
   and (narms.x >= enemy.x - 3*enemy.radius/2 and narms.x <= enemy.x + 3*enemy.radius/2)
   and (narms.y >= enemy.y - 3*enemy.radius/2 and narms.y <= enemy.y + 3*enemy.radius/2)
   and (narms.z + narms.height >= enemy.z and narms.z <= (enemy.z + enemy.height + 4*FRACUNIT))
    P_DamageMobj(enemy, narms, mo)
	
    local ang = R_PointToAngle2(narms.x, narms.y, mo.x, mo.y)
	
	if narms.state == S_NILARMS_RETURN1 or narms.state == S_NILARMS_RETURN2
    narms.state = S_NILARMS_RETURN1
    P_InstaThrust(narms, ang, FRACUNIT*2)
    mo.player.actionstate = 3
	mo.player.nillyarms.launchstate = 3
    narms.launchtime = TICRATE * 2
    mo.state = S_NILLY_ARMUSE_RETURN
	end
    return true
   end
  else return
  end
end, MT_NILARMS)

addHook("MobjLineCollide", function(mo, line)
 if (mo and mo.valid)
 and line and line.valid
	mo.lastline = line
 end
 return nil
end, MT_NILARMS)

addHook("MobjMoveBlocked", function(arms, mobj, _)
    if (arms and arms.valid) and (arms.target and arms.target.valid) 
	and arms.target.skin == SKIN
	and arms.lastline ~= nil
		local mo = arms.target
		local player = arms.target.player
	
		local line = arms.lastline
		
		if (mobj ~= nil) or not (line and line.valid) then return end

		if arms.state == S_NILARMS_ATTACK1 or mo.player.actionstate == 2 or mo.player.nillyarms.launchstate == 2
			arms.atwall = 3
	 
			player.norundist = R_PointToDist2(arms.target.x, arms.target.y, arms.x, arms.y)
			if (line.flags&ML_NOCLIMB)
				mo.player.actionstate = 3
				mo.player.nillyarms.launchstate = 3
				mo.player.nillyarms.launchtime = TICRATE * 2
				mo.state = S_NILLY_ARMUSE_RETURN
			end
		end
   else
		return
   end
end, MT_NILARMS)

addHook("AbilitySpecial", function(player)
 if (player.mo and player.mo.valid) and player.mo.skin == SKIN
  if player.nillyarms ~= nil and player.nillyarms.arms and player.nillyarms.arms.valid //and player.mo.target
   local narms = player.nillyarms.arms
   if narms.state == S_NILARMS1
				player.doubledash = nil
				player.dashticsleft = nil
				player.pflags = $ & ~PF_CANCARRY
				player.actionstate = 1
				player.nillyarms.launchstate = 1
     //player.mo.target = narms
     //P_HomingAttack(player.mo, player.nillyarms.arms)
     
     player.mo.state = S_PLAY_SPINDASH
     player.pflags = $|PF_THOKKED
     S_StartSound(player.mo, sfx_thok)
    return true
   end
  end
 else
  return
 end
end)

local function HandleHeight(player)
    if not player.mo then return end
    if player.mo.skin ~= SKIN then return end
    
    if player.mo.state == S_NILLY_CROUCH
        return P_GetPlayerSpinHeight(player)
    end
end

addHook("PlayerHeight", HandleHeight)
addHook("PlayerCanEnterSpinGaps", HandleHeight)